# Common files
require_relative 'mastercard_masterpass_merchant/version'
require_relative 'mastercard_masterpass_merchant/tracker/sdk_api_tracker'

# Models

require_relative 'mastercard_masterpass_merchant/models/merchant_initialization_request'

require_relative 'mastercard_masterpass_merchant/models/merchant_initialization_response'

require_relative 'mastercard_masterpass_merchant/models/shopping_cart_request'

require_relative 'mastercard_masterpass_merchant/models/shopping_cart_request_extension_point'

require_relative 'mastercard_masterpass_merchant/models/shopping_cart'

require_relative 'mastercard_masterpass_merchant/models/shopping_cart_item'

require_relative 'mastercard_masterpass_merchant/models/shopping_cart_response'

require_relative 'mastercard_masterpass_merchant/models/checkout'

require_relative 'mastercard_masterpass_merchant/models/card'

require_relative 'mastercard_masterpass_merchant/models/shipping_address'

require_relative 'mastercard_masterpass_merchant/models/authentication_options'

require_relative 'mastercard_masterpass_merchant/models/precheckout_data_request'

require_relative 'mastercard_masterpass_merchant/models/pairing_data_types'

require_relative 'mastercard_masterpass_merchant/models/pairing_data_type'

require_relative 'mastercard_masterpass_merchant/models/precheckout_data_response'

require_relative 'mastercard_masterpass_merchant/models/precheckout_data'

require_relative 'mastercard_masterpass_merchant/models/reward_programs'

require_relative 'mastercard_masterpass_merchant/models/precheckout_reward_program'

require_relative 'mastercard_masterpass_merchant/models/precheckout_cards'

require_relative 'mastercard_masterpass_merchant/models/precheckout_card'

require_relative 'mastercard_masterpass_merchant/models/card_extension'

require_relative 'mastercard_masterpass_merchant/models/payment_acceptance_types_extension'

require_relative 'mastercard_masterpass_merchant/models/card_types'

require_relative 'mastercard_masterpass_merchant/models/card_type'

require_relative 'mastercard_masterpass_merchant/models/contact'

require_relative 'mastercard_masterpass_merchant/models/date_of_birth'

require_relative 'mastercard_masterpass_merchant/models/precheckout_shipping_addresses'

require_relative 'mastercard_masterpass_merchant/models/precheckout_shipping_address'

require_relative 'mastercard_masterpass_merchant/models/reward_program'

require_relative 'mastercard_masterpass_merchant/models/address'

require_relative 'mastercard_masterpass_merchant/models/address_extension_point'

require_relative 'mastercard_masterpass_merchant/models/base_card'

require_relative 'mastercard_masterpass_merchant/models/merchant_transactions'

require_relative 'mastercard_masterpass_merchant/models/merchant_transaction'

require_relative 'mastercard_masterpass_merchant/models/merchant_initialization_extension'

require_relative 'mastercard_masterpass_merchant/models/payment_options_extensions'

require_relative 'mastercard_masterpass_merchant/models/installments'

require_relative 'mastercard_masterpass_merchant/models/installment'

require_relative 'mastercard_masterpass_merchant/models/brands'

require_relative 'mastercard_masterpass_merchant/models/issuers'

require_relative 'mastercard_masterpass_merchant/models/installment_options'

require_relative 'mastercard_masterpass_merchant/models/payment_acceptance'

require_relative 'mastercard_masterpass_merchant/models/acceptance_option'

require_relative 'mastercard_masterpass_merchant/models/types'

require_relative 'mastercard_masterpass_merchant/models/dsrp_extension'

require_relative 'mastercard_masterpass_merchant/models/dsrp_options'

require_relative 'mastercard_masterpass_merchant/models/option'

require_relative 'mastercard_masterpass_merchant/models/merchant_initialization_response_extension'

require_relative 'mastercard_masterpass_merchant/models/checkout_extension'

require_relative 'mastercard_masterpass_merchant/models/tokenization'

require_relative 'mastercard_masterpass_merchant/models/risk_decisioning'

require_relative 'mastercard_masterpass_merchant/models/wallet'

require_relative 'mastercard_masterpass_merchant/models/checkout_dsrp'

require_relative 'mastercard_masterpass_merchant/models/dsrp'

require_relative 'mastercard_masterpass_merchant/models/private_datas'

require_relative 'mastercard_masterpass_merchant/models/private_data'

require_relative 'mastercard_masterpass_merchant/models/installment_option'

require_relative 'mastercard_masterpass_merchant/models/extension_point'

require_relative 'mastercard_masterpass_merchant/models/errors'

require_relative 'mastercard_masterpass_merchant/models/express_checkout_request'

require_relative 'mastercard_masterpass_merchant/models/express_checkout_response'

require_relative 'mastercard_masterpass_merchant/models/error'

require_relative 'mastercard_masterpass_merchant/models/details'

require_relative 'mastercard_masterpass_merchant/models/detail'

require_relative 'mastercard_masterpass_merchant/models/decryption_request'

require_relative 'mastercard_masterpass_merchant/models/decryption_response'

require_relative 'mastercard_masterpass_merchant/models/session_key_signing_request'

require_relative 'mastercard_masterpass_merchant/models/session_key_signing_response'


# APIs


require_relative 'mastercard_masterpass_merchant/api/checkout_api'

require_relative 'mastercard_masterpass_merchant/api/session_key_signing_api'

require_relative 'mastercard_masterpass_merchant/api/precheckout_data_api'

require_relative 'mastercard_masterpass_merchant/api/express_checkout_api'

require_relative 'mastercard_masterpass_merchant/api/decryption_api'

require_relative 'mastercard_masterpass_merchant/api/postback_api'

require_relative 'mastercard_masterpass_merchant/api/merchant_initialization_api'

require_relative 'mastercard_masterpass_merchant/api/shopping_cart_api'




module MastercardMasterpassMerchant
  class << self
    # Customize default settings for the SDK using block.
    #   MastercardMasterpassMerchant.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
