require 'uri'
require 'mastercard_core_sdk'
require_relative '../../mastercard_masterpass_merchant/models/decryption_response'
require_relative '../../mastercard_masterpass_merchant/models/decryption_request'
 

module MastercardMasterpassMerchant
 module Api

  class DecryptionApi
    include MastercardCoreSdk::Core, MastercardCoreSdk::Client, MastercardCoreSdk::Exceptions
	  include MastercardMasterpassMerchant::Tracker


    # Decryption Service
    # Decryption Service Android SDK.
    # @param decryption_request Decryption Service.
    # @param api_config Optional ApiConfig object specifying configuration : consumer key, private key, host URL. 
    # @return [DecryptionResponse]
    def self.create(decryption_request, api_config = nil)
		 path = "/masterpass/v6/decrypt"
	 	 service_request = ServiceRequest.new
     
	   
	   service_request.body = decryption_request
	 
	   service_request.content_type = "application/xml"
	   api_client = ApiClient.new(api_config)
     api_client.api_tracker = SdkApiTracker.new
     api_client.error_handler = ErrorHandler.new
	   return api_client.call(path, service_request, "POST",DecryptionResponse)
    end

  end

 end
end



