require 'uri'
require 'mastercard_core_sdk'
require_relative '../../mastercard_masterpass_merchant/models/session_key_signing_response'
require_relative '../../mastercard_masterpass_merchant/models/session_key_signing_request'
 

module MastercardMasterpassMerchant
 module Api

  class SessionKeySigningApi
    include MastercardCoreSdk::Core, MastercardCoreSdk::Client, MastercardCoreSdk::Exceptions
	  include MastercardMasterpassMerchant::Tracker


    # Session Key Signing
    # Session Key Signing Android SDK.
    # @param session_key_signing_request Session Key Signing request.
    # @param api_config Optional ApiConfig object specifying configuration : consumer key, private key, host URL. 
    # @return [SessionKeySigningResponse]
    def self.create(session_key_signing_request, api_config = nil)
		 path = "/masterpass/v6/sessionkeysigning"
	 	 service_request = ServiceRequest.new
     
	   
	   service_request.body = session_key_signing_request
	 
	   service_request.content_type = "application/xml"
	   api_client = ApiClient.new(api_config)
     api_client.api_tracker = SdkApiTracker.new
     api_client.error_handler = ErrorHandler.new
	   return api_client.call(path, service_request, "POST",SessionKeySigningResponse)
    end

  end

 end
end



