require 'uri'
require 'mastercard_core_sdk'
require_relative '../../mastercard_masterpass_merchant/models/shopping_cart_response'
require_relative '../../mastercard_masterpass_merchant/models/shopping_cart_request'
 

module MastercardMasterpassMerchant
 module Api

  class ShoppingCartApi
    include MastercardCoreSdk::Core, MastercardCoreSdk::Client, MastercardCoreSdk::Exceptions
	  include MastercardMasterpassMerchant::Tracker


    # ShoppingCart service
    # This service used to enables shopping cart data to be displayed to users as they proceed through the MasterPass login and checkout.Merchants must call the Shopping Cart service before invoking the MasterPass UI for checkout.
    # @param shopping_cart_request Shopping Cart Request.
    # @param api_config Optional ApiConfig object specifying configuration : consumer key, private key, host URL. 
    # @return [ShoppingCartResponse]
    def self.create(shopping_cart_request, api_config = nil)
		 path = "/masterpass/v6/shopping-cart"
	 	 service_request = ServiceRequest.new
     
	   
	   service_request.body = shopping_cart_request
	 
	   service_request.content_type = "application/xml"
	   api_client = ApiClient.new(api_config)
     api_client.api_tracker = SdkApiTracker.new
     api_client.error_handler = ErrorHandler.new
	   return api_client.call(path, service_request, "POST",ShoppingCartResponse)
    end

  end

 end
end



