require 'date'
require 'roxml'
 

module MastercardMasterpassMerchant
  # This class contains methods require to set installment details.
  class InstallmentOption
    include ROXML
    
    xml_name "InstallmentOption"
    
    # @!attribute number_of_installments
    # @return [Integer] the number of installments.
    xml_accessor :number_of_installments, :from =>"NumberOfInstallments"
   
    # @!attribute price_per_installment
    # @return [Integer] the price per installment.
    xml_accessor :price_per_installment, :from =>"PricePerInstallment"
   
    # @!attribute interest_rate
    # @return [String] the interest rate.
    xml_accessor :interest_rate, :from =>"InterestRate"
   
    # @!attribute currency_code
    # @return [String] the currency code.
    xml_accessor :currency_code, :from =>"CurrencyCode"
   

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :number_of_installments => :NumberOfInstallments ,
        :price_per_installment => :PricePerInstallment ,
        :interest_rate => :InterestRate ,
        :currency_code => :CurrencyCode 
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes.has_key?(:NumberOfInstallments) ||  attributes.has_key?(:number_of_installments)
        self.number_of_installments = attributes[:NumberOfInstallments] || attributes[:number_of_installments]
      end
      
      if attributes.has_key?(:PricePerInstallment) ||  attributes.has_key?(:price_per_installment)
        self.price_per_installment = attributes[:PricePerInstallment] || attributes[:price_per_installment]
      end
      
      if attributes.has_key?(:InterestRate) ||  attributes.has_key?(:interest_rate)
        self.interest_rate = attributes[:InterestRate] || attributes[:interest_rate]
      end
      
      if attributes.has_key?(:CurrencyCode) ||  attributes.has_key?(:currency_code)
        self.currency_code = attributes[:CurrencyCode] || attributes[:currency_code]
      end
      
    end
    
 
	

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          number_of_installments == o.number_of_installments &&
          price_per_installment == o.price_per_installment &&
          interest_rate == o.interest_rate &&
          currency_code == o.currency_code
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [number_of_installments, price_per_installment, interest_rate, currency_code].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.datatype_map.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = MastercardMasterpassMerchant.const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    private
    def after_parse
      self.send(:remove_instance_variable, :@roxml_references) if defined? self.roxml_references
    end
    
    # Attribute datatype mapping.
    def self.datatype_map
      {
        :number_of_installments => 'Integer',
        :price_per_installment => 'Integer',
        :interest_rate => 'String',
        :currency_code => 'String'
        
      }
    end
  end


end
