require 'date'
require 'roxml'
require_relative '../../mastercard_masterpass_merchant/models/extension_point'
require_relative '../../mastercard_masterpass_merchant/models/precheckout_data'
 

module MastercardMasterpassMerchant
  # This class returns the precheckout data.
  class PrecheckoutDataResponse
    include ROXML
    
    xml_name "PrecheckoutDataResponse"
    
    # @!attribute precheckout_data
    # @return [PrecheckoutData] the precheckout data details.
    xml_accessor :precheckout_data, :from =>"PrecheckoutData",:as => PrecheckoutData
   
    # @!attribute wallet_partner_logo_url
    # @return [String] the wallet partner logo url.
    xml_accessor :wallet_partner_logo_url, :from =>"WalletPartnerLogoUrl"
   
    # @!attribute masterpass_logo_url
    # @return [String] the MasterPass logo url.
    xml_accessor :masterpass_logo_url, :from =>"MasterpassLogoUrl"
   
    # @!attribute long_access_token
    # @return [String] the long access token.
    xml_accessor :long_access_token, :from =>"LongAccessToken"
   
    # @!attribute extension_point
    # @return [ExtensionPoint] the ExtensionPoint for future enhancement.
    xml_accessor :extension_point, :from =>"ExtensionPoint",:as => ExtensionPoint
   

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :precheckout_data => :PrecheckoutData ,
        :wallet_partner_logo_url => :WalletPartnerLogoUrl ,
        :masterpass_logo_url => :MasterpassLogoUrl ,
        :long_access_token => :LongAccessToken ,
        :extension_point => :ExtensionPoint 
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes.has_key?(:PrecheckoutData) ||  attributes.has_key?(:precheckout_data)
        self.precheckout_data = attributes[:PrecheckoutData] || attributes[:precheckout_data]
      end
      
      if attributes.has_key?(:WalletPartnerLogoUrl) ||  attributes.has_key?(:wallet_partner_logo_url)
        self.wallet_partner_logo_url = attributes[:WalletPartnerLogoUrl] || attributes[:wallet_partner_logo_url]
      end
      
      if attributes.has_key?(:MasterpassLogoUrl) ||  attributes.has_key?(:masterpass_logo_url)
        self.masterpass_logo_url = attributes[:MasterpassLogoUrl] || attributes[:masterpass_logo_url]
      end
      
      if attributes.has_key?(:LongAccessToken) ||  attributes.has_key?(:long_access_token)
        self.long_access_token = attributes[:LongAccessToken] || attributes[:long_access_token]
      end
      
      if attributes.has_key?(:ExtensionPoint) ||  attributes.has_key?(:extension_point)
        self.extension_point = attributes[:ExtensionPoint] || attributes[:extension_point]
      end
      
    end
    
 
	

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          precheckout_data == o.precheckout_data &&
          wallet_partner_logo_url == o.wallet_partner_logo_url &&
          masterpass_logo_url == o.masterpass_logo_url &&
          long_access_token == o.long_access_token &&
          extension_point == o.extension_point
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [precheckout_data, wallet_partner_logo_url, masterpass_logo_url, long_access_token, extension_point].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.datatype_map.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = MastercardMasterpassMerchant.const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    private
    def after_parse
      self.send(:remove_instance_variable, :@roxml_references) if defined? self.roxml_references
    end
    
    # Attribute datatype mapping.
    def self.datatype_map
      {
        :precheckout_data => 'PrecheckoutData',
        :wallet_partner_logo_url => 'String',
        :masterpass_logo_url => 'String',
        :long_access_token => 'String',
        :extension_point => 'ExtensionPoint'
        
      }
    end
  end


end
